;; Problem 160
;; 07 September 2007
;; For any N, let f(N) be the last five digits before the trailing zeroes in N!.
;;  For example,
;; 9! = 362880 so f(9)=36288
;;  10! = 3628800 so f(10)=36288
;;  20! = 2432902008176640000 so f(20)=17664
;; Find f(1,000,000,000,000)


(defun find-prod (max-iters &optional (ndigits 100000) (period 10000000000))
  (declare (optimize speed))
  (loop for ii from 1 to max-iters
	for prod = 1 then (* prod
			     (let ((nn (mod ii ndigits))) 
			       (if (= 0 nn) 1 nn)))
	finally (return prod)
	do
	(loop
	 while (= 0 (mod prod 10))
	 do
	 (setf prod (/ prod 10)))
	(setf prod (mod prod ndigits))
	(when (= 0 (mod ii period))
	  (format t "ii:~a prod:~a~&" ii prod))))

;; we don't need to actually do the 'big' multiplication...
;(mod (* 12345 12345) 100000)  => 99025
;(mod (* 912345 12345) 100000) => 99025

; (/ 1000000000000 100000)
; 10,000,000
;                1000000000000

(assert (= 36288 (time (find-prod  9 100000 1000000))))

(assert (= 36288 (time (find-prod 10 100000 1000000))))

(assert (= 17664 (time (find-prod 20 100000 1000000))))


;;(find-prod  5)     12
;;(find-prod 25)  10984
;;(/ 10984 12)

;; multiplying by anything which is divisible by 10 does nothing, so
;; we can skip those, but that's only a small portion of the iteration
;; space can we collapse 2 and 5 paris then?  Any pair which
;; multiplied results in a divisble by 10?

;(find-prod 9)   36288
;(find-prod 10)  36288

(find-prod 19)    8832
(find-prod 20)   17664

;(find-prod 99)  16864
;(find-prod 100) 16864
(time (find-prod 10000000 100000 1000000))

;; (loop for ii from 1000000 to 1000100
;;       do
;;       (format t "; (find-prod ~10d) ; => ~10d~&" 
;; 	      ii (find-prod ii)))

;; (labels ((tmp (ii)
;; 	   (format t "; (find-prod ~10d) ; => ~10d~&" ii (find-prod ii))))
;;   (mapcar #'tmp  '(1000000 1100000 1200000)))

;; (labels ((tmp (ii)
;; 	   (format t "; (find-prod ~10d) ; => ~10d~&" ii (find-prod ii))))
;;   (mapcar #'tmp  '(1000000 2000000 3000000 4000000 5000000 )))





'(with-open-file (out "/home/mortis/personal/projects/project-euler/out.txt"
		     :direction :output
		     :if-exists :supersede)
  (loop for ii from 1 to 100000
	do
	(format out "; (find-prod ~10d) ; => ~10d~&" 
		ii (find-prod ii))))
  

;; ; (find-prod          9) ; =>      36288
;; ; (find-prod         10) ; =>      36288
;; ; (find-prod       1337) ; =>      36288
;; ; (find-prod       2814) ; =>      36288
;; ; (find-prod       5124) ; =>      36288
;; ; (find-prod       9743) ; =>      36288
;; ; (find-prod      10943) ; =>      36288
;; (/ 2814 1337);;  402/191
;; (- 2814 1337);; 1477
;; (/ 5124 2814);;  122/67
;; (- 5124 2814);; 2310
;; (/ 9743 5124);; 9743/5124 - prime?
;; (- 9743 5124);; 4619




(loop for ii in '(9 
		  99
		  999
		  9999
		  99999
		  999999
		  9999999
		  99999999
		  )
      do
      (format t "; (find-prod ~10d) ; => ~10d~&" 
	      ii (find-prod ii)))


; (find-prod          9) ; =>      36288
; (find-prod         99) ; =>      16864
; (find-prod        999) ; =>      53472
; (find-prod       9999) ; =>      79008
; (find-prod      99999) ; =>       2496
; (find-prod     999999) ; =>      88576
; (find-prod    9999999) ; =>      61376
; (find-prod   99999999) ; =>      29376



(loop for ii in '(9 
		  90
		  990
		  9990
		  99990
		  999990
		  9999990
		  )
      do
      (format t "; (find-prod ~10d) ; => ~10d~&" 
	      ii (find-prod ii)))

; (find-prod          9) ; =>      36288
; (find-prod         90) ; =>      78112
; (find-prod        990) ; =>       5056
; (find-prod       9990) ; =>      81184
; (find-prod      99990) ; =>      69408
; (find-prod     999990) ; =>       9248
; (find-prod    9999990) ; =>      83648

;(find-prod 50) ; 10512
;(find-prod 10);  36288
;(find-prod 450); 40688

;(find-prod 500); 12864


(find-prod 2);   2
(find-prod 3);   6
(find-prod 4);  24
(find-prod 5); 120
(find-prod 6); 720